#include <signal.h>
#include <stdio.h>
#include <stdlib.h>

static void sigill_handler(int ignored)
{
  fprintf(stderr, "Got SIGILL exception.\n");
  exit(1);
}

static void sigsegv_handler(int ignored)
{
  fprintf(stderr, "Got SIGSEGV exception.\n");
  exit(1);
}

int main()
{
  signal(SIGILL, sigill_handler);
  signal(SIGSEGV, sigsegv_handler);

  fprintf(stderr, "Triggering SIGILL exception (halfword aligned rsubeq instruction):\n");
  asm(".balignw 4, 0xd703");   /* Align on 4 bytes, pad with NOPs. */
  asm("nop"); /* Make sure that the illegal opcode is aligned at a half-word boundary. */
  asm("rsubeq r0, 42"); /* Illegal opcode. */
  fprintf(stderr, "Exception didn't trigger.\n");

  return 0;
}
